#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "settings.h"

Settings settings;

void loadsettings()
{
	settings.minidemo = false;
	
	settings.numcells = 50;
	settings.numbees = 173;
	settings.vectors = false;
	settings.eventms = 100;

	FILE* f = fopen( "Hive.cfg", "r" );
	if ( !f )
	{
		return;
	}
	char c[64];
	while ( fgets( c, 64, f ) )
	{
		     if ( !memcmp( c, "numcells=", 9 ) )
			settings.numcells = atoi( c+9 );
		else if ( !memcmp( c, "numbees=", 8 ) )
			settings.numbees = atoi( c+8 );
		else if ( !memcmp( c, "vectors=T", 9 ) )
			settings.vectors = true;
		else if ( !memcmp( c, "vectors=F", 9 ) )
			settings.vectors = false;
		else if ( !memcmp( c, "eventms=", 8 ) )
			settings.eventms = atoi( c+8 );
	}

	fclose( f );

	//Sanity checks
	if ( settings.numcells < 2 ) settings.numcells = 2;
	if ( settings.numbees < 0 ) settings.numbees = 0;
	if ( settings.eventms < 1 ) settings.eventms = 1;
}

void savesettings()
{
	FILE* f = fopen( "Hive.cfg", "w" );
	if ( !f ) return;

	fprintf( f, "#\n#\n# HIVE SCREENSAVER SETTINGS\n#\n" );

	fprintf( f, "# Number of cells\n" );
	fprintf( f, "numcells=%d\n", settings.numcells );

	fprintf( f, "# Number of bees\n" );
	fprintf( f, "numbees=%d\n", settings.numbees );

	fprintf( f, "# Debug vectors visible\n" );
	fprintf( f, "vectors=%c\n", settings.vectors ? 'T' : 'F' );

	fprintf( f, "# Milliseconds between bee swap events\n" );
	fprintf( f, "eventms=%d\n", settings.eventms );

	fclose( f );
}
